<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC
    "-//W3C//DTD XHTML 1.1 plus MathML 2.0 plus SVG 1.1//EN"
    "http://www.w3.org/2002/04/xhtml-math-svg/xhtml-math-svg.dtd">
<html xmlns:svg='http://www.w3.org/2000/svg' xml:lang='en' xmlns='http://www.w3.org/1999/xhtml'>
<head><meta content='application/xhtml+xml;charset=utf-8' http-equiv='Content-type' /><title>xdock API (version 0.2.0)</title></head>
<body>
<h1 id='xdock_api_version_020'>xdock API (version 0.2.0)</h1>

<p>This document describes the API used to develop <strong>xdock</strong> clients.</p>

<p>Important:</p>

<ul>
<li>the dock is 64x64 pixels, so all position parameters must be between 0 and 63.</li>

<li><code>uchar</code> means <code>unsigned char</code>.</li>
</ul>
<hr />
<h2 id='table_of_contents'>Table of contents</h2>
<div class='maruku_toc'><ul style='list-style: none;'><li><a href='#table_of_contents'>Table of contents</a></li><li><a href='#connection_functions'>Connection functions</a><ul style='list-style: none;'><li><a href='#id1'><code>int xd_connect()</code></a></li><li><a href='#id2'><code>void xd_disconnect()</code></a></li><li><a href='#id3'><code>void xd_flush()</code></a></li></ul></li><li><a href='#versions'>Versions</a><ul style='list-style: none;'><li><a href='#id4'><code>const char* xd_version()</code></a></li></ul></li><li><a href='#basic_drawing_functions'>Basic drawing functions</a><ul style='list-style: none;'><li><a href='#id5'><code>void xd_draw_point(uchar color, uchar x, uchar y)</code></a></li><li><a href='#id6'><code>xd_draw_line(uchar color, uchar x1, uchar y1, uchar x2, uchar y2)</code></a></li><li><a href='#id7'><code>xd_draw_rectangle(uchar color, uchar x1, uchar y1, uchar x2, uchar y2)</code></a></li><li><a href='#id8'><code>xd_draw_box(uchar fgcolor, uchar bgcolor, uchar x1, uchar y1, uchar x2, uchar y2)</code></a></li></ul></li><li><a href='#themed_commands'>Themed commands</a><ul style='list-style: none;'><li><a href='#id9'><code>void xd_led_draw_panel(uchar x1, uchar y1, uchar x2, uchar y2)</code></a></li></ul></li><li><a href='#advanced_operations'>Advanced operations</a><ul style='list-style: none;'><li><a href='#id10'><code>void xd_move_box(uchar x1, uchar y1, uchar x2, uchar y2, uchar direction, uchar step, uchar bg_color)</code></a></li><li><a href='#id11'><code>void xd_write(uchar font, uchar x, uchar y, const char* text)</code></a></li><li><a href='#id12'><code>void xd_send_xpm(uchar n, char** xpm)</code></a></li><li><a href='#id13'><code>void xd_draw_image(uchar n, uchar x, uchar y)</code></a></li><li><a href='#id14'><code>void xd_set_color(uchar color, uchar r, uchar g, uchar b)</code></a></li></ul></li><li><a href='#events'>Events</a><ul style='list-style: none;'><li><a href='#id15'><code>void xd_grab_events(uchar event_mask, uchar x1, uchar y1, uchar x2, uchar y2)</code></a></li><li><a href='#id16'><code>xd_next_event(xd_event_t* event)</code></a></li></ul></li><li><a href='#standard_color_list'>Standard color list</a></li></ul></div><hr />
<h2 id='connection_functions'>Connection functions</h2>

<p>These functions deal with the connection with the xdock server.</p>

<h3 id='id1'><code>int xd_connect()</code></h3>

<blockquote>
<p><em>Description</em>: connects to the server in localhost and creates a blank square. It must be called before any other <strong>xdock</strong> function is called.</p>
</blockquote>

<blockquote>
<p><em>Returns</em>: -1 if connection was sucessful, 0 is not.</p>
</blockquote>

<h3 id='id2'><code>void xd_disconnect()</code></h3>

<blockquote>
<p><em>Description</em>: closes the connection with the server. It&#8217;s not necessary to call this function at the end of the execution of the program, use it to close the connection during the execution.</p>
</blockquote>

<h3 id='id3'><code>void xd_flush()</code></h3>

<blockquote>
<p><em>Description</em>: all changes to the dock are made to memory only. Use this function to update all operations to the screen.</p>
</blockquote>
<hr />
<h2 id='versions'>Versions</h2>

<h3 id='id4'><code>const char* xd_version()</code></h3>

<blockquote>
<p><em>Description</em>: returns the xdock version.</p>
</blockquote>
<hr />
<h2 id='basic_drawing_functions'>Basic drawing functions</h2>

<p>These functions perform basic drawing.</p>

<h3 id='id5'><code>void xd_draw_point(uchar color, uchar x, uchar y)</code></h3>

<blockquote>
<p><em>Description</em>: draw a point (one pixel).</p>
</blockquote>

<blockquote>
<p><em>Parameters</em>:</p>

<ul>
<li><code>color</code> - color of the point</li>

<li><code>x</code>, <code>y</code> - the position of the point</li>
</ul>
</blockquote>

<h3 id='id6'><code>xd_draw_line(uchar color, uchar x1, uchar y1, uchar x2, uchar y2)</code></h3>

<blockquote>
<p><em>Description</em>: draw a line</p>
</blockquote>

<blockquote>
<p><em>Parameters</em>:</p>

<ul>
<li><code>color</code> - color of the line</li>

<li><code>x1</code>, <code>y1</code> - position of the beginning of the line</li>

<li><code>x2</code>, <code>y2</code> - position of the end of the line</li>
</ul>
</blockquote>

<h3 id='id7'><code>xd_draw_rectangle(uchar color, uchar x1, uchar y1, uchar x2, uchar y2)</code></h3>

<blockquote>
<p><em>Description</em>: draw a rectangle</p>
</blockquote>

<blockquote>
<p><em>Parameters</em>:</p>

<ul>
<li><code>color</code> - color of the rectangle lines</li>

<li><code>x1</code>, <code>y1</code> - position of the top/left of the rectangle</li>

<li><code>x2</code>, <code>y2</code> - position of the bottom/right of the rectangle</li>
</ul>
</blockquote>

<h3 id='id8'><code>xd_draw_box(uchar fgcolor, uchar bgcolor, uchar x1, uchar y1, uchar x2, uchar y2)</code></h3>

<blockquote>
<p><em>Description</em>: draw a filled rectangle</p>
</blockquote>

<blockquote>
<p><em>Parameters</em>:</p>

<ul>
<li><code>bgcolor</code> - color of the rectangle lines</li>

<li><code>fgcolor</code> - color of the rectangle background</li>

<li><code>x1</code>, <code>y1</code> - position of the top/left of the rectangle</li>

<li><code>x2</code>, <code>y2</code> - position of the bottom/right of the rectangle</li>
</ul>
</blockquote>
<hr />
<h2 id='themed_commands'>Themed commands</h2>

<p>These function perform drawing based on a theme. Currently, only the LED theme is available.</p>

<h3 id='id9'><code>void xd_led_draw_panel(uchar x1, uchar y1, uchar x2, uchar y2)</code></h3>

<blockquote>
<p><em>Description</em>: draw a filled rectangle that serves as a LED panel. The berder of the panel is 2 pixel wide, so remember to make <em>move</em> operations one pixel inside the panel. The background of the panel is the color <code>XD_LED_BG</code>.</p>
</blockquote>

<blockquote>
<p><em>Parameters</em>:</p>

<ul>
<li><code>x1</code>, <code>y1</code> - position of the top/left of the panel</li>

<li><code>x2</code>, <code>y2</code> - position of the bottom/right of the panel</li>
</ul>
</blockquote>
<hr />
<h2 id='advanced_operations'>Advanced operations</h2>

<p>These functions are more advanced drawing operations.</p>

<h3 id='id10'><code>void xd_move_box(uchar x1, uchar y1, uchar x2, uchar y2, uchar direction, uchar step, uchar bg_color)</code></h3>

<blockquote>
<p><em>Description</em>: move the contents inside the square (defined by x1, y1, x2, y2) a few pixels to a given direction.</p>
</blockquote>

<blockquote>
<p><em>Parameters</em>:</p>

<ul>
<li><code>x1</code>, <code>y1</code> - position of the top/left of the box</li>

<li><code>x2</code>, <code>y2</code> - position of the bottom/right of the box</li>

<li><code>direction</code> - direction where the contents of the box will move to. Possible options are: <code>XD_UP</code>, <code>XD_DOWN</code>, <code>XD_LEFT</code> and <code>XD_RIGHT</code>.</li>

<li><code>step</code>: number of pixels the contents of the box will move.</li>

<li><code>bg_color</code>: the color that will be left where there were pixels, before moving.</li>
</ul>
</blockquote>

<h3 id='id11'><code>void xd_write(uchar font, uchar x, uchar y, const char* text)</code></h3>

<blockquote>
<p><em>Description</em>: write text on the box.</p>
</blockquote>

<blockquote>
<p><em>Parameters</em>:</p>

<ul>
<li><code>font</code> - the font to be used. Currently, the only option is <code>XD_FONT_LED_1</code>.</li>

<li><code>x</code>, <code>y</code> - position of the top/left of the text</li>

<li><code>text</code> - text to be written. Must be <code>null</code> terminated.</li>
</ul>
</blockquote>

<h3 id='id12'><code>void xd_send_xpm(uchar n, char** xpm)</code></h3>

<blockquote>
<p><em>Description</em>: send a XPM image to the server. A XPM image can be created with <a href='http://www.gimp.org/'>GIMP</a> and linked into the executable. The colors of the image need not to be defined with <code>xd_set_color</code>.</p>
</blockquote>

<blockquote>
<p><em>Parameters:</em></p>

<ul>
<li><code>n</code> - the number of the image. It can be any number from 0 to 255. This number will be used to refer to the image when drawing it.</li>

<li><code>xpm</code> - the XPM structure.</li>
</ul>
</blockquote>

<h3 id='id13'><code>void xd_draw_image(uchar n, uchar x, uchar y)</code></h3>

<blockquote>
<p><em>Description</em>: draw a XPM image defined with <code>xd_send_xpm</code>.</p>
</blockquote>

<blockquote>
<p><em>Parameters</em>:</p>

<ul>
<li><code>n</code> - the number of the image, defined when the image was sent to the server.</li>

<li><code>x</code>, <code>y</code> - position of the top/left of the image.</li>
</ul>
</blockquote>

<h3 id='id14'><code>void xd_set_color(uchar color, uchar r, uchar g, uchar b)</code></h3>

<blockquote>
<p><em>Description</em>: define a new color.</p>
</blockquote>

<blockquote>
<p><em>Parameters:</em></p>

<ul>
<li><code>color</code> - the number of the color. It must be between 128 and 255. Colors below 128 are reserved.</li>

<li><code>r</code>, <code>g</code> and <code>b</code>: amount of red, green and blue, respectively. Between 0 and 255.</li>
</ul>
</blockquote>
<hr />
<h2 id='events'>Events</h2>

<h3 id='id15'><code>void xd_grab_events(uchar event_mask, uchar x1, uchar y1, uchar x2, uchar y2)</code></h3>

<blockquote>
<p><em>Description:</em> calling this function means that the server will start sending to the client all events (such as mousepresses) that occur within the area described by the parameters x1, y1, x2 and x2. Only the parameters set my the <code>event_mask</code> parameters will be caught. If this function is called more than once, then the last call replaces the previous one. The area outside outside the defined event area is used to drag the dock to a new position. It is recommended that is left a area of at least 4 pixels in each side.</p>
</blockquote>

<blockquote>
<p><em>Parameters:</em></p>

<ul>
<li><code>event_mask</code> - the type of event that&#8217;ll be caught. It can be one of: <code>MOUSE_DOWN</code>, <code>MOUSE_UP</code> and <code>MOUSE_PRESS</code>. <code>MOUSE_PRESS</code> emulates a click on a button, when the mouse is pressed and released without moving.</li>

<li><code>x1</code>, <code>y2</code>, <code>x2</code> and <code>y2</code> - the confined area where the events will be caught. Any mousepresses ouside this area will drag the dock.</li>
</ul>
</blockquote>

<h3 id='id16'><code>xd_next_event(xd_event_t* event)</code></h3>

<blockquote>
<p><em>Description:</em> gets the next event from the server. It&#8217;s a non blocking function, and it will return 1 if a event is on the queue, and 0 if the queue is empty. The next event in queue is returned in the parameter <code>event</code>.</p>
</blockquote>

<blockquote>
<p><em>Parameters:</em></p>

<ul>
<li><code>event</code> - a event structure that will return the event. The structure of this parameter is defined below.</li>

<li>Don&#8217;t pass NULL on this parameter.</li>
</ul>
</blockquote>

<pre><code>typedef struct
{
    unsigned char type; // Type of event: MOUSE_DOWN, MOUSE_UP or MOUSE_PRESS
    unsigned char x;
    unsigned char y;
    unsigned char button; // Mouse button pressed: 1 (left), 2 (middle) or 3(right)
} xd_event_t;</code></pre>
<hr />
<h2 id='standard_color_list'>Standard color list</h2>

<p>The following colors are available standard from <strong>xdock</strong>. You can create your own colors with <code>xd_set_color</code>.</p>
<table border='1'>
<tr><th>Name</th><th>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</th><th>R</th><th>G</th><th>B</th></tr>

<tr><td>XD_BLACK</td><td bgcolor='#000000' /><td>00</td><td>00</td><td>00</td></tr>
<tr><td>XD_GRAY_10</td><td bgcolor='#191919' /><td>19</td><td>19</td><td>19</td></tr>
<tr><td>XD_GRAY_20</td><td bgcolor='#333333' /><td>33</td><td>33</td><td>33</td></tr>
<tr><td>XD_GRAY_30</td><td bgcolor='#4C4C4C' /><td>4C</td><td>4C</td><td>4C</td></tr>
<tr><td>XD_GRAY_40</td><td bgcolor='#656565' /><td>65</td><td>65</td><td>65</td></tr>
<tr><td>XD_GRAY_50</td><td bgcolor='#7F7F7F' /><td>7F</td><td>7F</td><td>7F</td></tr>
<tr><td>XD_GRAY_60</td><td bgcolor='#989898' /><td>98</td><td>98</td><td>98</td></tr>
<tr><td>XD_GRAY_70</td><td bgcolor='#B1B1B1' /><td>B1</td><td>B1</td><td>B1</td></tr>
<tr><td>XD_GRAY_80</td><td bgcolor='#CACACA' /><td>CA</td><td>CA</td><td>CA</td></tr>
<tr><td>XD_GRAY_90</td><td bgcolor='#E3E3E3' /><td>E3</td><td>E3</td><td>E3</td></tr>
<tr><td>XD_WHITE</td><td bgcolor='#FFFFFF' /><td>FF</td><td>FF</td><td>FF</td></tr>

<tr><td>XD_LED_BG</td><td bgcolor='#1B1B1B' />     <td>1B</td><td>1B</td><td>1B</td></tr>
<tr><td>XD_LED_UNLIT_1</td><td bgcolor='#004840' /><td>00</td><td>48</td><td>40</td></tr>
<tr><td>XD_LED_UNLIT_2</td><td bgcolor='#007C70' /><td>00</td><td>7C</td><td>70</td></tr>
<tr><td>XD_LED_LIT_1</td><td bgcolor='#188880' />  <td>18</td><td>88</td><td>80</td></tr>
<tr><td>XD_LED_LIT_2</td><td bgcolor='#20B0A8' />  <td>20</td><td>B0</td><td>A8</td></tr>
<tr><td>XD_LED_GLOW</td><td bgcolor='#00E800' />   <td>00</td><td>E8</td><td>00</td></tr>

</table></body></html>
